/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package model2;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;

/**
 *
 * @author dienert
 */
public class DbZugriff {

    Connection dbVerbindung;
    Statement sqlStatement;
    ResultSet ergebnisTabelle;

    public DbZugriff() {

        try {
            Class.forName("org.postgresql.Driver");

            dbVerbindung = DriverManager.getConnection(
                    "jdbc:postgresql:emaille",
                    "alfred", //benutzer der datenbank
                    "mad" //sein passwort
            );

            sqlStatement = dbVerbindung.createStatement(
                    ResultSet.TYPE_SCROLL_INSENSITIVE,
                    ResultSet.CONCUR_READ_ONLY
            );

        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    ArrayList sucheAdressenVonUser(Person user) throws SQLException {
        ArrayList liste = new ArrayList();

        PreparedStatement prepStat = 
                this.dbVerbindung.prepareStatement(
                "select email "
                + "from benutzer inner join emailaddr "
                + "on benutzer.id = emailaddr.name "
                + "where benutzer.nachname ilike ? "
                + "or benutzer.vorname ilike ?"
        );
        prepStat.setString(1, user.getNachname());
        prepStat.setString(2, user.getVorname());
        
        ergebnisTabelle = prepStat.executeQuery();
                

        while (ergebnisTabelle.next()) {
            liste.add(ergebnisTabelle.getString("email"));
        }

        return liste;
    }

    public static void main(String[] args) {
        DbZugriff dbz = new DbZugriff();
        ArrayList<String> testliste = null;
        Person person = new Person();
        //person.setVorname("asd' ; delete from benutzer; --");
        try {
            testliste = dbz.sucheAdressenVonUser(person);
        } catch (Exception e) {
            e.printStackTrace();
        }
        for(String item: testliste){System.out.println(item);}
    }

}
